#include <stdio.h>
#include <string.h>

struct treeNode {
	char word[30];
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

void insertNode(LEAFNODEPTR *, char *);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);


main()
{

	LEAFNODEPTR root = NULL;
	char line[100],*p;
	
	printf("enter a line:");
	gets(line);
	
	p = strtok(line," ");
	
	while(p != NULL) {
		insertNode(&root, p);
		p = strtok(NULL," ");
	}
	
	inOrder(root);
	printf("\n");
	postOrder(root);
	printf("\n");
	preOrder(root);
	printf("\n");
	
}


void insertNode(LEAFNODEPTR *root, char *word)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			strcpy((*root)->word,word);
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if( strcmp(word,(*root)->word) > 0)
			insertNode(&((*root)->leftPtr), word);
		else
			if(strcmp(word,(*root)->word) < 0)
				insertNode(&((*root)->rightPtr), word);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %s -",root->word);
		inOrder(root->rightPtr);
	}
	
}

void preOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		printf("- %s -",root->word);
		inOrder(root->leftPtr);
		inOrder(root->rightPtr);
	}
}

void postOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		inOrder(root->rightPtr);
		printf("- %s -",root->word);
	}
}