#include <stdio.h>
#include <stdlib.h>
#include <time.h>

int rollDice(void);
int playGame(void);
void chatter(int);

int wintotal[21] = {0};
int losetotal[21] = {0};

main()
{

int i;

srand(time(NULL));

for(i = 0; i < 1000; i++)
	playGame();
	
for(i = 1; i <= 20; i++)
	printf("%2d Rolls: %3d Wins, %3d Losses\n",i,wintotal[i],losetotal[i]);


return 0;

} /* End Main */




int playGame()
{

int gameStatus, sum, myPoint, rolls=0;

sum = rollDice();

switch(sum) {
	case 7:	case 11:
		gameStatus = 1;
		rolls++;
		break;
	case 2:	case 3:	case 12:
		gameStatus = 2;
		rolls++;
		break;
	default:
		gameStatus = 0;
		myPoint = sum;
		printf("Point is %d\n", myPoint);
		rolls++;
		break;
}

while (gameStatus == 0) {
	sum = rollDice();
	rolls++;
	if(sum == myPoint)
		gameStatus = 1;
	else
		if (sum == 7)
			gameStatus = 2;
}

if(gameStatus == 1) {
	printf("Player wins\n");
	if(rolls <= 20) wintotal[rolls]++; else wintotal[20]++;
} else {
	printf("Player loses\n");
	if(rolls <= 20) loseteotal[rolls]++; else losetotal[20]++;
	
return gameStatus;

}/* End playGame */

int rollDice(void)
{

int die1, die2, workSum;

die1 = 1 + (rand() % 6);
die2 = 1 + (rand() % 6);
workSum = die1 + die2;
printf("Player rolled %d + %d = %d \n", die1, die2, workSum);
return workSum;

}

void chatter(int balance)
{

int random;

random = rand() % 4;

if(balance < 250 && random == 2)
	printf("Oh, you're going for broke, huh?\n");
else if((balance > 250 && balance < 750) && random == 1)
	printf("Aw com, take a chance!\n");
else if(balance > 100 && random == 3)
	printf("You're up big. Now's the time to cash in your chips!\n");
	
}