#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAZESIZE 12

int traverse(const char[][], const int, const int);

main()
{

	char maze[MAZESIZE][MAZESIZE] = {{1,1,1,1,1,1,1,1,1,1,1,1},
								{1,0,0,0,1,0,0,0,0,0,0,1},
								{0,0,1,0,1,0,1,1,1,1,0,1},
								{1,1,1,0,1,0,0,0,0,1,0,1},
								{1,0,0,0,0,1,1,1,0,1,0,0},
								{1,1,1,1,0,1,0,1,0,1,0,1},
								{1,0,0,1,0,1,0,1,0,1,0,1},
								{1,1,0,1,0,1,0,1,0,1,0,1},
								{1,0,0,0,0,0,0,0,0,1,0,1},
								{1,1,1,1,1,1,0,1,1,1,0,1},
								{1,0,0,0,0,0,0,1,0,0,0,1},
								{1,1,1,1,1,1,1,1,1,1,1,1}
								};
	 int startx = 0;
	 int starty = 2;
	 
	 traverse(maze, startx, starty);

	 for(startx = 0; startx < 12; startx++)
	 	for(starty = 0; starty < 12; starty++) {
	 		printf("%d",maze[startx][starty]);
	 		if(starty == 11)
	 			printf("\n");
	 	}
	 	
}


int traverse(const char maze[][], const int startx, const int starty)
{

	int turn(int *, int);
	int i = MAZESIZE,j = MAZESIZE;
	int xPosition = startx;
	int yPosition = starty;
	int direction = 0;
	
	if(xPosition == 11)
		direction = 3;
	if(xPosition == 0)
		direction = 1;
	if(yPosition == 0)
		direction = 2;
	if(yPosition == 1)
		direction = 0;

	do {
		switch(direction) {
			case 0:
				yPosition--;
				if(maze[xPosition][yPosition] == 1) {
					turn(&direction,1);
					yPosition++;
				}
				break;
			case 1:
				xPosition++;
				if(maze[xPosition][yPosition] == 1) {
					turn(&direction,1);
					xPosition--;
				}
				break;
			case 2:
				yPosition++;
				break;
			case 3:
				xPosition--;
				break;
		}
								
	} while((xPosition != 0) && (xPosition != 11) && (yPosition != 0) && (yPosition != 11));

}

int turn(int *direction, int change)
{

	*direction += change;
	if(direction < 0)
		direction *= -1;
	*direction %= 4;
	
};	