#include <stdio.h>

struct treeNode {
	int data;
	struct treeNode *leftPtr;
	struct treeNode *rightPtr;
};

typedef struct treeNode LEAFNODE;
typedef LEAFNODE *LEAFNODEPTR;

void insertNode(LEAFNODEPTR *, int);
void preOrder(LEAFNODEPTR);
void postOrder(LEAFNODEPTR);
void inOrder(LEAFNODEPTR);


main()
{

	LEAFNODEPTR root = NULL;
	
	insertNode(&root, 7);
	insertNode(&root, 8);
	insertNode(&root, 4);
	insertNode(&root, 1);
	insertNode(&root, 9);
	insertNode(&root, 8);
	
	inOrder(root);
	
}


void insertNode(LEAFNODEPTR *root, int data)
{

	if(*root == NULL) {
		*root = malloc(sizeof(LEAFNODE));
		
		if(*root != NULL) {
			(*root)->data = data;
			(*root)->leftPtr = NULL;
			(*root)->rightPtr = NULL;
		} else 
			printf("Memory not allocated - can't add leaf\n");
		
	} else 
		if(data < (*root)->data)
			insertNode(&((*root)->leftPtr), data);
		else
			if(data > (*root)->data)
				insertNode(&((*root)->rightPtr), data);
			else
				printf("duplicate\n");
	
} /*end insertNode*/

void inOrder(LEAFNODEPTR root)
{

	if(root != NULL) {
		inOrder(root->leftPtr);
		printf("- %d -",root->data);
		inOrder(root->rightPtr);
	}
	
}