#include <stdio.h>

struct queueNode {
	char string[20];
	struct queueNode *next;
};

typedef struct queueNode NODE;
typedef NODE *NODEPTR;

int enqueue(NODEPTR *,NODEPTR *, char []);
char *dequeue(NODEPTR *, NODEPTR *);
void printqueue(NODEPTR);


main()
{

	NODEPTR head = NULL, tail = NULL;
	char *sp;

	head = tail;
	
	enqueue(&head,&tail,"first in first out");
	enqueue(&head,&tail,"middle");
	enqueue(&head,&tail,"more middle");
	enqueue(&head,&tail,"last in last out");
	sp = dequeue(&head,&tail);
	printf("Item: %s\n",sp);
	free(sp);
	sp = dequeue(&head,&tail);
	free(sp);
	sp = dequeue(&head,&tail);
	free(sp);
	sp = dequeue(&head,&tail);
	printf("Item2: %s\n",sp);
	free(sp);
	enqueue(&head,&tail,"test");
	printqueue(head);
	
}

char *dequeue(NODEPTR *head, NODEPTR *tail)
{

	NODEPTR deadNode;
	char *string;
	
	string = malloc(20);
	
	if(*head == NULL) {
		printf("Queue is empty\n");
		return NULL;
	}
	
	deadNode = *head;
	strcpy(string,deadNode->string);
	*head = (*head)->next;
	free(deadNode);
	
	return string;	

}		

int enqueue(NODEPTR *head,NODEPTR *tail, char string[])
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	strncpy(newNode->string,string,20);
	newNode->next = NULL;

	if(*head == NULL) {
		*head = newNode;
	} else {
		(*tail)->next = newNode;
	}

	*tail = newNode;
	
} /* end enqueue */
	

void printqueue(NODEPTR head)
{

	if(head == NULL) {
		printf("Queue is empty\n");
	} else {
		while(head != NULL) {
			printf("%s\n", head->string);
			head = head->next;
		}
	}
	
} /* end printqueue */
