#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define SIZE 10

void quickSort(int [], const int);

main()
{

	int array[SIZE];
	int i;
	
	srand(time(NULL));
	for(i = 0; i < SIZE; i++)
		array[i] = rand() % 100;

	for(i = 0; i < SIZE; i++)
		printf("%d ",array[i]);
	printf("\n");
		
	quickSort(array,i-1);
	
	printf("returned\n");
	
	for(i = 0; i < SIZE; i++)
		printf("%d ",array[i]);
	printf("\n");
}

void quickSort(int array[], const int length)
{

	int i,j;
	int newLoc=0,oldLoc = length;
	void swap(int *,int *);

	if(length <= 1)
		return;
	if(length == 2) {
		if(array[length-1] < array[0])
			swap(&array[length-1],&array[0]);
		return;	
	}
	
	printf("sorting string of length %d\n",length);
	while(newLoc != oldLoc) {
		for(i = oldLoc; i >= newLoc; i--)
			if(array[i] <= array[newLoc]) {
				swap(&array[i],&array[newLoc]);
				printf("1: %d(%d) %d(%d)\n",array[i],i,array[newLoc],newLoc);
				oldLoc = newLoc;
				newLoc = i;
				i = -1;
			}
		printf("%d %d\n",oldLoc,newLoc);
		for(j = oldLoc; j <= newLoc; j++)
			if(array[j] >= array[newLoc]) {
				swap(&array[j],&array[newLoc]);
				printf("2: %d(%d) %d(%d)\n",array[j],j,array[newLoc],newLoc);
				oldLoc = newLoc;
				newLoc = j;
				j = 9999;
			}
	}	

	printf("%d\n",newLoc+1);
	quickSort(array,newLoc-1);
	quickSort(&array[newLoc+1],length - (newLoc+1));
			
}

void swap(int *x1,int *x2)
{

	int temp;
	temp = *x1;
	*x1 = *x2;
	*x2 = temp;
	
}