#include <stdio.h>

struct stackNode {
	char string;
	struct stackNode *next;
};

typedef struct stackNode NODE;
typedef NODE *NODEPTR;

int push(NODEPTR *, char );
char pop(NODEPTR *);
void dump(NODEPTR);

main()
{

	NODEPTR firstNode = NULL;
	char *string,*string2;
	char c;
	
	string = malloc(1024);
	
	printf("please enter a string of text:");
	gets(string);

	string2 = string;

	printf("%s ",string);

	while(*string2) {
		if(isalnum(*string2))
			push(&firstNode,*string2);
		string2++;
	}

	while((c = pop(&firstNode)) != NULL) {
		while(!isalnum(*string))
			string++;
		if(*string != c) {
			printf("is not a palindrome\n");
			return;
		}
		string++;
	}
	
	printf("is a palindrome\n",string);
		
}


char pop(NODEPTR *topNode)
{

	NODEPTR deadNode,nextNode;
	char c;

	nextNode = *topNode;
	
	if(*topNode == NULL) {
		return(0);
	} else {
		deadNode = nextNode;
		*topNode = nextNode->next;
		c = deadNode->string;
		free(deadNode);
	}

	return c;

}

int push(NODEPTR *topNode, char string)
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	
	newNode->string = string;
	newNode->next = NULL;

	newNode->next = *topNode;
	*topNode = newNode;


}

void dump(NODEPTR topNode)
{

	if(topNode == NULL) {
		printf("Stack is empty\n");
	} else {
		while(topNode != NULL) {
			printf("%c\n",topNode->string);
			topNode = topNode->next;
		}
	}

}