#include <stdio.h>

int putpixel(int xloc, int yloc);
int pendown(void);
int penup(void);
int forward(int length);
int turn(int direction);
int printfloor(void);
int jump(int xfin, int yfin);

int x=0,y=0,pen=0,facing=0;
int floor[50][50] = {0};

void main()
{

	int command=0, arg1=0,arg2=0;

	while(command != 9) {
		printf("What is your command? ");
		scanf("%1d,%2d,%2d",&command,&arg1,&arg2);
		switch(command) {
			case 1: 
				penup();
				break;
			case 2:
				pendown();
				break;
			case 3:
				turn(1);
				break;
			case 4:
				turn(-1);
				break;
			case 5:
				forward(arg1);
				break;
			case 6:
				printfloor();
				break;
			case 7:
				jump(arg1, arg2);
				break;
			case 8:
				printf("debugging info:\n");
				printf("command: %d  arg1: %d  arg2: %d\n",command,arg1,arg2);
				printf("x: %d  y: %d  pen: %d  facing: %d\n",x,y,pen,facing);
				break;
			case 9: 
				break;
			default:
				printf("fatal error - bad command - shutting down\n");
				command = 9;
				break;
		}
	}

} /* end main */


int jump(int xfin, int yfin)
{

	x = xfin;
	y = yfin;

} /*end jump() */

int pendown(void) 
{

	pen = 1;

} /* end pendown() */;


int penup(void)
{

	pen = 0;

}/* end pendown() */


int forward(int length) 
{

	if(pen == 1)
		putpixel(x,y);

	switch(facing) {
		case 0:
			x--;
			if(x < 0)
				x = 49;
			break;
		case 3:
			y--;
			if(y < 0)
				y = 49;
			break;
		case 2:
			x++;
			if(x > 49)
				x = 0;
			break;
		case 1:
			y++;
			if(y > 49)
				y = 0;
			break;
	}

	length--;
	if(length > 1) 
		forward(length);
	
	if(pen == 1)
		putpixel(x,y);

}/*end forward() */

int turn(int direction)
{

	facing = (facing + direction) % 4;
	if(facing < 0)
		facing *= -1;

} /*end turn*/


int printfloor(void)
{

	int i,j;
	
	for(i = 0; i < 50; i++) {
		for(j = 0; j < 50; j++)
			if(floor[i][j] == 1)
				printf("*");
			else
				printf(" ");
		printf("\n");
	}

} /* end printfloor */


int putpixel(int xloc, int yloc)
{

	floor[xloc][yloc] = 1;

} /*end putpixel*/