#include <stdio.h>

#define BOUNDTEST ( (currentrow <= 7) && (currentrow > -1) && (currentcolumn <= 7) && (currentcolumn > -1) )

const int vertical[8] = { -1,-2, -2, -1,  1,  2, 2, 1};
const int horizontal[8] = {2, 1, -1, -2, -2, -1, 1, 2};
static int board[8][8] = {0};
int accessibility[8][8] = {{2,3,4,4,4,4,3,2},
									{3,4,6,6,6,6,4,3},
									{4,6,8,8,8,8,6,4},
									{4,6,8,8,8,8,6,4},
									{4,6,8,8,8,8,6,4},
									{4,6,8,8,8,8,6,4},
									{3,4,6,6,6,6,4,3},
									{2,3,4,4,4,4,3,2}
									};


int choosemovenumber(int, int);

main()
{

	int i=0,j=0;
	int movenumber=0;
	int tourcounter=0;
	int currentrow=0;
	int currentcolumn=0;
	int goodmove=0;
	int fulltours = 0;

//for(i = 0; i < 8; i++)
	for(j = 0; j < 8; j++) {
	currentrow = 0;
	currentcolumn = j;
	printf("trying %d,%d",currentcolumn,currentrow);
	for(tourcounter = 1; tourcounter <= 64; tourcounter++) {
		goodmove=0;
		movenumber=0;
		movenumber = choosemovenumber(currentrow,currentcolumn);
		if(movenumber < 0) {
			printf("out of possibilities at move %d\n",tourcounter);
			tourcounter = 99;
			break;
		}
      currentrow += vertical[movenumber];
		currentcolumn += horizontal[movenumber];
		board[currentcolumn][currentrow] = tourcounter;

	}
	
	if(tourcounter == 65) {
		printf("fulltour\n");
		fulltours++;
	}
}
	
printf("\n\nFull Tours: %d\n\n",fulltours);

	for(i = 0; i < 8; i++) {
		for(j = 0; j < 8; j++)
			printf("%3d",board[i][j]); 
		printf("\n");
	}


	
}		


int choosemovenumber(int currentrow, int currentcolumn)
{

	int i,j;
	int movenumber = 0;
	int bestmove = -1;
	int bestmoveaccess = 9;

	
	movenumber = 0;
	while(movenumber < 8) {
		currentrow += vertical[movenumber];
		currentcolumn += horizontal[movenumber];
		if(board[currentcolumn][currentrow] != 0) {
			currentrow -= vertical[movenumber];
			currentcolumn -= horizontal[movenumber];
			movenumber++;
			continue;
		} 
		if(!BOUNDTEST) {
			currentrow -= vertical[movenumber];
			currentcolumn -= horizontal[movenumber];
			movenumber++;
			continue;
		}
		if(accessibility[currentcolumn][currentrow] < bestmoveaccess) {
			bestmoveaccess = accessibility[currentcolumn][currentrow];
			bestmove = movenumber;
		}
		currentrow -= vertical[movenumber];
		currentcolumn -= horizontal[movenumber];
		movenumber++;
	}
	

	return(bestmove);
}