#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define BOUNDTEST ( (currentrow <= 7) && (currentrow > -1) && (currentcolumn <= 7) && (currentcolumn > -1) )

const int vertical[8] = { -1,-2, -2, -1,  1,  2, 2, 1};
const int horizontal[8] = {2, 1, -1, -2, -2, -1, 1, 2};
static int board[8][8] = {0};

int choosemovenumber(int, int);
int clearboard(void);

main()
{

	int i=0,j=0;
	int movenumber=0;
	int tourcounter=0;
	int currentrow=0;
	int currentcolumn=0;
	int goodmove=0;
	int fulltours = 0;

srand(time(NULL));

	currentrow = 0;
	currentcolumn = 0;
	printf("trying %d,%d",currentcolumn,currentrow);
	for(tourcounter = 1; tourcounter <= 64; tourcounter++) {
		goodmove=0;
		movenumber=0;
		movenumber = choosemovenumber(currentrow,currentcolumn);
		if(movenumber < 0) {
			printf("out of possibilities at move %d\n",tourcounter);
			tourcounter = 99;
			break;
		}
      currentrow += vertical[movenumber];
		currentcolumn += horizontal[movenumber];
		board[currentcolumn][currentrow] = tourcounter;

	}

	clearboard();	

	if(tourcounter == 65) {
		printf("fulltour\n");
		fulltours++;
	}

	
printf("\n\nFull Tours: %d\n\n",fulltours);

	for(i = 0; i < 8; i++) {
		for(j = 0; j < 8; j++)
			printf("%3d",board[i][j]); 
		printf("\n");
	}


	
}		


int choosemovenumber(int currentrow, int currentcolumn)
{

	int i=0,j=0,x=0;
	int movenumber = 0;
	int movepossibility[8] = {0};
	int movetest[8] = {0};
	
	movenumber = 0;
	while(i == 0) {
		movenumber = rand() % 8;
		printf("%d ",movenumber);
		if(movetest[movenumber] != 0) {
			for(x = 0; x < 8; x++) {
				if(movetest[x] == 0) j = 1;
				printf("! %d !",movetest[x]);
			}
			if(j != 1) {
				i = -1;
			printf("moo");}
			continue;
		}
		currentrow += vertical[movenumber];
		currentcolumn += horizontal[movenumber];
		if(board[currentcolumn][currentrow] != 0) {
			currentrow -= vertical[movenumber];
			currentcolumn -= horizontal[movenumber];
			movetest[movenumber] = 1;
			continue;
		} 
		if(!BOUNDTEST) {
			currentrow -= vertical[movenumber];
			currentcolumn -= horizontal[movenumber];
			movetest[movenumber] = 1;
			continue;
		}
		printf("lady! ");
		currentrow -= vertical[movenumber];
		currentcolumn -= horizontal[movenumber];
		i = 1;
	}
	
	if(i == -1)
		return(-1);
	else
		return(movenumber);
}

int clearboard(void)
{

int i,j;

for(i = 0; i < 8; i++)
	for(j = 0; j < 8; j++)
		board[i][j] = 0;

}