#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void shuffle(int [][13]);
void deal(int [][13], const char *[], const char *[], int [][2]);
int evaluate(int [][2]);

main()
{

	int i,j;
	char *suit[4] = {"Hearts","Diamonds","Clubs","Spades"};
	char *face[13] = {"Ace","Deuce","Three","Four","Five","Six",
							"Seven","Eight","Nine","Ten","Jack","Queen","King"};
	int deck[4][13] = {0};
	int hand[5][2] = {0};
	
	srand(time(NULL));
	
	shuffle(deck);
	deal(deck,face,suit,hand);

	hand[0][0] = 1;
	hand[1][0] = 2;
	hand[2][0] = 1;
	hand[3][0] = 1;
	hand[4][0] = 1;

	evaluate(hand);
	
	return 0;
	
}


int evaluate(int hand[][2])
{

	int i,j;
	int pair1 = 0, pair2 = 0,pairs = 0, ofakind1 = 0, ofakind2 = 0, status = 0;
	
	for(j = 1; j < 5; j++) {
		i = j;
		printf("\n");
		while(i != 5) {
			printf("%d-%d\t",j-1,i);
			if(hand[j-1][0] == hand[i++][0]) {
				if(pair1 == 0)
					pair1 = hand[j-1][0];
				if(pair1 == hand[j-1][0]) {
					ofakind1++;
					continue;
				}
				if(pair1 != 0)
					pair2 = hand[j-1][0];
				if(pair2 == hand[j-1][0])
					ofakind2++;
			}
		}
	}

	if((pair2 == 0) && (ofakind1 == 1))
		status = 1;
	if((pair1 != 0) && (pair2 != 0) && (ofakind1 == 1) && (ofakind2 == 1))
		status = 2;
	if( (pair1 != 0) && ((ofakind1 == 2) || (ofakind2 == 2)) )
		status = 3;
	if( (pair1 != 0) && (( ofakind1 == 3) || (ofakind2 == 3)) )
		status = 4;



	printf("pair1: %d  pair2: %d  ofakind1: %d  ofakind2: %d\n",pair1,pair2,ofakind1,ofakind2);
	printf("status: %d\n",status);
	return 0;
}
	

void shuffle(int wDeck[][13])
{
	int card, row, column;
	
	for(card = 1; card <= 52; card++) {
		row = rand() % 4;
		column = rand() % 13;
		
		while(wDeck[row][column] != 0) {
			row = rand() % 4;
			column = rand() % 13;
		}
		
		wDeck[row][column] = card;
	}
}

void deal(int wDeck[][13], const char *wFace[], const char *wSuit[], int hand[][2])
{

	int card, row, column, i;
	
	for(i = 1; i < 6; i++) {
		card = (rand() % 52) + 1;
		for(row = 0; row <= 3; row++)
			
			for(column = 0; column <= 12; column++) {
				if(wDeck[row][column] == card * 1000) {
					i--;
					column = 13;
					row = 4;
				}
				if(wDeck[row][column] == card) {
					hand[i-1][0] = column;
					hand[i-1][1] = row;
					printf("%5s of %-8s\n",wFace[column],wSuit[row]);
					wDeck[row][column] = card * 1000;
				}
			}
	}
}