#include <stdio.h>

struct stackNode {
	char string[20];
	struct stackNode *next;
};

typedef struct stackNode NODE;
typedef NODE *NODEPTR;

int push(NODEPTR *, char []);
char *pop(NODEPTR *);
void dump(NODEPTR);

main()
{

	NODEPTR firstNode = NULL;

	push(&firstNode,"hello world");
	push(&firstNode,"hello again");
	push(&firstNode,"moo");
	printf("Popped %s\n",pop(&firstNode));
	printf("Popped %s\n",pop(&firstNode));
	
	dump(firstNode);
	
}


char *pop(NODEPTR *topNode)
{

	NODEPTR deadNode,nextNode;
	char *string;

	string = malloc(20);
	nextNode = *topNode;
	
	if(*topNode == NULL) {
		printf("Stack is Empty. No nodes to Pop\n");
		return(NULL);
	} else {
		deadNode = nextNode;
		*topNode = nextNode->next;
		strcpy(string,deadNode->string);
		free(deadNode);
	}

	return string;

}

int push(NODEPTR *topNode, char string[])
{

	NODEPTR newNode;
	
	(NODEPTR)newNode = malloc(sizeof(NODE));
	
	strncpy(newNode->string,string,20);
	newNode->next = NULL;

	newNode->next = *topNode;
	*topNode = newNode;


}

void dump(NODEPTR topNode)
{

	if(topNode == NULL) {
		printf("Stack is empty\n");
	} else {
		while(topNode != NULL) {
			printf("%s\n",topNode->string);
			topNode = topNode->next;
		}
	}

}